#include "mainwindow.h"
#include "ui_mainwindow.h"

#include <QtSql/QSqlDatabase>
#include <QSqlRelationalTableModel>
#include <QSqlRelationalDelegate>
#include <QSqlQuery>
#include <QSqlRecord>
#include <QStringListModel>

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);

    QSqlDatabase db = QSqlDatabase::addDatabase( "QSQLITE" );
    db.setDatabaseName(":memory:");
    db.open();

    db.exec( "CREATE TABLE test (n_id INTEGER PRIMARY KEY, name TEXT)" );
    db.exec( "INSERT INTO test VALUES (1, 'one'), (2, 'two'), (3, 'three')" );
    db.exec( "CREATE TABLE main (id INTEGER PRIMARY KEY, n_id INTEGER)" );
    db.exec( "INSERT INTO main VALUES (1, 1), (2, 2), (3, 3)" );

    this->mdl = new QSqlRelationalTableModel(this);
    this->mdl->setTable( "main" );
    this->mdl->setRelation( 1, QSqlRelation("test", "n_id", "name") );
    this->mdl->select();
    this->mdl->relationModel( 1 )->setSort( 1, Qt::AscendingOrder );
    this->mdl->relationModel( 1 )->select();

    this->ui->sourceView->setModel( this->mdl );
    this->ui->sourceView->setItemDelegate(new QSqlRelationalDelegate(this->ui->sourceView));
}

MainWindow::~MainWindow()
{
    delete ui;
}
